;(function(){

    window._w.appointmentedit = {

        itemId : null,
        itemData : null,
        formMeta : null,
        ti : null,
        limited : false,
        newItem : false,
        validations : 0,
        highestOfferId : false,
        priceGuideId : false,
        publicCentreList : {},
        isModalForm : true,
        idSource : 'appointmentedit',

        onValuationAppointmentEditTemplateReady : function( template, event, eventData )
        {
            _w.appointmentedit.itemData = null;
            _w.appointmentedit.ti = _t[template];
            _w.appointmentedit.limited = false;

            //console.log('_w.appointmentId',_w.appointmentId);

            App.DataStore.loadSelectListData('appointmentTimeSlot', true, 'Valuation', 'ValuationTimeSlots.SelectList');

            _w.appointmentedit.setCalendarValuationViewFormMeta();
            _w.appointmentedit.ti.hydrate(_w.appointmentedit.formMeta);
            // Retrieve initial view data.
            _w.appointmentedit.itemId = '' != _w.appointmentId && undefined != _w.appointmentId ? _w.appointmentId : 0;

            _w.appointmentedit.newItem = true;
            _w.appointmentedit.itemData = {ValuationAppointments:{}};
            //App.API.getTask(
            //    'createappointmentedit', 'Valuation', 'ValuationAppointments.Create',
            //    null, {}, function(){}, _w.taskContractError
            //);

            App.API.getTask(
                'calendarValuationUpdate:' + _w.appointmentedit.itemId, 'Valuation', 'ValuationAppointments.Update', null,
                {'id':_w.appointmentedit.itemId}, $.proxy( _w.appointmentedit._onCalendarValuationViewDataReceived, this ), _w.taskContractError
            );

            //App.API.getTask(
            //    'calendarValuationCreate:' + _w.appointmentedit.itemId, 'Valuation', 'ValuationAppointments.Create', _w.appointmentedit.itemId,
            //    {'id':_w.appointmentedit.itemId}, $.proxy( _w.appointmentedit._onCalendarValuationViewDataReceived, this ), _w.taskContractError
            //);

            //App.API.getTask(
            //    'calendarValuationUpdate:' + _w.appointmentedit.itemId, 'Valuation', 'ValuationAppointments.Update', null,
            //    {'id':_w.appointmentedit.itemId},
            //    $.proxy( function(responce){
            //
            //        console.log('responce',responce);
            //
            //        App.API.execTask(
            //            'calendarValuationUpdate:' + _w.appointmentedit.itemId, {'id':_w.appointmentedit.itemId}, {},
            //            $.proxy( _w.appointmentedit._onCalendarValuationViewDataReceived, this ),
            //            _w.customercompletevaluation._onValuationFail
            //        );
            //    },this),
            //    _w.taskContractError
            //);

            //App.API.execTask(
            //    'createCustomerValuation', data, {},
            //    _w.customercompletevaluation._onValuationUpdated,
            //    _w.customercompletevaluation._onValuationFail
            //);
        },

        onValuationAppointmentEditPublished : function( template, event, eventData )
        {
            $('#frmModal').modal({
                backdrop 	: 'static',
                show 		: true
            });

            _w.appointmentedit.limited = false;
            _w.appointmentedit._setupValidation();

            $('#btnSaveAppointment').prop('disabled', true);
            $('#btnSaveAppointment').show();

        },

        _onCalendarValuationViewDataReceived : function( response )
        {
            console.log('response.Data',response.Data);

            _w.appointmentedit.itemId = response.Data.id;
            _w.appointmentedit.itemData = response.Data;
            _w.appointmentedit.setCalendarValuationViewFormMeta(response.Data);
            _w.appointmentedit.ti.hydratePartial(_w.appointmentedit.formMeta);
            if (_w.appointmentedit.ti.published)
            {
                _w.appointmentedit._setupValidation();
            }
        },

        setCalendarValuationViewFormMeta : function(data)
        {
            if (!data)
            {
                data = {"ValuationAppointments":{},"valuation":{},"timeSlot":{}};
            }

            console.log('data'.data);

            if(undefined != data.appointmentDate)
            {
                _w.appointmentDateData = data.appointmentDate.replace(/ 00:00:00/g,'');
            }
            if(undefined != data.timeSlot && undefined != data.timeSlot.timeSlot)
            {
                var appointmentTimeSlotData = data.timeSlot.timeSlot.split(' - ');

                _w.appointmentTimeSlotData = appointmentTimeSlotData[1];
            }

            _w.appointmentedit.formMeta = {

                'firstName' : {
                    type  : 'input',
                    id    : 'firstName',
                    title : 'Name',
                    value : data.valuation.firstName ? data.valuation.firstName : ''
                },
                'familyName' : {
                    type  : 'input',
                    id    : 'familyName',
                    title : 'Surname',
                    value : data.valuation.familyName ? data.valuation.familyName : ''
                },
                'email' : {
                    type  : 'input',
                    id    : 'email',
                    title : 'Email address',
                    value : data.valuation.email ? data.valuation.email : ''
                },
                'mobile' : {
                    type  : 'mobile',
                    id    : 'mobile',
                    title : 'Mobile',
                    value : data.valuation.mobile ? data.valuation.mobile : ''
                },

                'appointmentDate' : {
                    type  : 'input',
                    id    : 'appointmentDate',
                    title : 'Appointment Date',
                    style : 'datepicker',
                    value : data.appointmentDate ? data.appointmentDate.replace(/ 00:00:00/g,'') : ''
                },

                'timeSlot' : {
                    type        : 'select',
                    id          : 'timeSlot',
                    title       : 'Appointment Time',
                    dataStoreId : 'appointmentTimeSlot',
                    value       : data.timeSlot.id ? data.timeSlot.id : ''
                },

                'appointmentCancelledComments' : {
                    type  : 'textarea-styled',
                    disabled	: false,
                    id    : 'appointmentCancelledComments',
                    title : 'Cancellation Reason',
                    style : 'damages-comments',
                    value : data.appointmentCancelledComments ? data.appointmentCancelledComments : ''
                },

                'appointmentCompleted': {
                    type: 'checkbox',
                    id: 'appointmentCompleted',
                    title: 'Appointment Completed',
                    value: data.appointmentCompleted ? data.appointmentCompleted : false
                },

                'appointmentCancelled': {
                    type: 'checkbox',
                    id: 'appointmentCancelled',
                    title: 'Cancel Appointment',
                    value: data.appointmentCancelled ? data.appointmentCancelled : false
                },


                'customerAddressStreet' : {
                    type  : 'input',
                    id    : 'customerAddressStreet',
                    title : 'Street/Unit/Building No',
                    value : data.valuation.customerAddressStreet ? data.valuation.customerAddressStreet : ''
                },
                'customerAddressStreetName' : {
                    type  : 'input',
                    id    : 'customerAddressStreetName',
                    title : 'Street Name',
                    value : data.valuation.customerAddressStreetName ? data.valuation.customerAddressStreetName : ''
                },
                'customerAddressSuburb' : {
                    type  : 'input',
                    id    : 'customerAddressSuburb',
                    title : 'Suburb / District',
                    value : data.valuation.customerAddressSuburb ? data.valuation.customerAddressSuburb : ''
                },
                'customerAddressCity' : {
                    type  : 'input',
                    id    : 'customerAddressCity',
                    title : 'City / Town',
                    value : data.valuation.customerAddressCity ? data.valuation.customerAddressCity : ''
                },
                'customerAddressPostalCode' : {
                    type  : 'input',
                    id    : 'customerAddressPostalCode',
                    title : 'Postal Code',
                    value : data.valuation.customerAddressPostalCode ? data.valuation.customerAddressPostalCode : ''
                }
            };
        },

        _listMakesModelsTypes : function( fromItemData, callback )
        {

        },

        _setupValidation : function ()
        {

            $('#btnSaveAppointment').click(function () {
                $('#btnSaveAppointment').prop('disabled', true);
                $('#terms').prop('disabled', true);
                if (!$('#frmAppointmentView').valid())
                {
                    $('#btnSaveAppointment').prop('disabled', false);
                    return;
                }


                var data = _w.appointmentedit._prepValuationUpdateData();

                console.log('data',data);

                App.API.execTask(
                    'calendarValuationUpdate:' + _w.appointmentedit.itemId, data, {},
                    _w.appointmentedit._onValuationUpdated,
                    _w.appointmentedit._onValuationFail
                );
            });

            $('.appointmentCancelledComments').hide();
            $('.appointmentCompleted').hide();
            $('.datepicker').datepicker({format:"yyyy-mm-dd"});

            if($('#appointmentCancelled').is(':checked'))
            {
                $('.appointmentCancelledComments').show();
                $('.appointmentCancelledComments').removeClass('hide');
                $('#appointmentCancelledComments').attr('required',true);
            }

            $('#appointmentCancelled').change(function() {

                if($('#appointmentCancelled').is(':checked'))
                {
                    $('.appointmentCancelledComments').show();
                    $('.appointmentCancelledComments').removeClass('hide');
                    $('#appointmentCancelledComments').attr('required',true);
                }
                else
                {
                    $('.appointmentCancelledComments').hide();
                    $('#appointmentCancelledComments').removeAttr('required')
                }
            });

            var calendarAppointmentDateData = _w.appointmentDateData.replace(/-/g,'');
            var calendarAppointmentTimeSlotData = _w.appointmentTimeSlotData.replace(/:/g,'');

            var date = new Date();
            var day = (date.getDate() < 10 ? '0' : '') + date.getDate();

            var month = ((date.getMonth() + 1) < 10 ? '0' : '') + (date.getMonth() + 1);
            var year = date.getFullYear();
            var hour = (date.getHours() < 10 ? '0' : '') + date.getHours();
            var minutes = (date.getMinutes() < 10 ? '0' : '') + date.getMinutes();

            if(year+month+day+hour+minutes > calendarAppointmentDateData+calendarAppointmentTimeSlotData)
            {
                $('.appointmentCompleted').show();
                $('.appointmentCompleted').removeClass('hide');
            }

            $('#appointmentCompleted').change(function() {

                if($('#appointmentCompleted').is(':checked'))
                {
                    $('.appointmentCancelled').hide();
                    $('.appointmentCancelledComments').hide();
                }
                else
                {
                    $('.appointmentCancelled').show();
                    if($('#appointmentCancelled').is(':checked'))
                    {
                        $('.appointmentCancelledComments').show();
                    }
                }
            });


            App.DataStore.listen('regValidation', 'damages', function(id, damages) {
                var rules = {
                    firstName: {required: true, minlength: 3},
                    familyName: {required: true, minlength: 3},
                    email: {required: true, email: true},
                    mobile: {required: true, mobile: true},
                    requiredPrice: {required: true, number: true, min: 0.01},
                    amountOffered: {required: true, number: true, min: 0.01},

                    customerAddressStreet: {required: true},
                    customerAddressStreetName: {required: true},
                    customerAddressSuburb: {required: true},
                    customerAddressCity: {required: true},
                    customerAddressPostalCode: { required: true, digits: true }

                };
                for (var i = 0; i < damages.length; i++)
                {
                    rules['damage' + damages[i].value + 'Amount'] = {number: true};
                }
                $('#frmAppointmentView').validate({
                    "rules": rules,
                    messages: {
                        firstName: {
                            minlength: "This field is required."
                        },
                        familyName: {
                            minlength: "This field is required."
                        },
                        email: {
                            required: "This field is required.",
                            email: "Please enter a valid<br/>email address."
                        },
                        customerAddressStreet : "This field is required.",
                        customerAddressStreetName : "This field is required.",
                        customerAddressSuburb : "This field is required.",
                        customerAddressCity : "This field is required.",
                        customerAddressPostalCode : {required: "This field is required."}
                    },
                    invalidHandler: function(event, validator) {
                        var errors = validator.numberOfInvalids();
                        if (0 < _w.appointmentedit.validations && errors) {
                            var message = errors == 1
                                ? 'You missed 1 field. It has been highlighted'
                                : 'You missed ' + errors + ' fields. They have been highlighted';
                            alert(message);
                        }
                        _w.appointmentedit.validations++;
                    },
                    submitHandler: function( form ) {
                        return;
                    }
                });
                try {
                    _w.appointmentedit.validations = 0;
                    $('#frmAppointmentView').valid();
                } catch(err) {}
                $('label.error').remove();
                $('.valid').removeClass('valid');
            });
        },

        _prepValuationUpdateData : function()
        {
            function isValidEmailAddress(emailAddress) {
                var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i);
                return pattern.test(emailAddress);
            };

            var data = _w.appointmentedit.ti.harvest();


            var postData = {ValuationAppointments:{}, Valuation:{}};
            var valuationFields = [
                "firstName","familyName","mobile",
                "email", "customerAddressStreet", "customerAddressStreetName", "customerAddressSuburb", "customerAddressCity", "customerAddressPostalCode",
                "requiredPrice"
            ];
            for (var field in data)
            {
                if (-1 == valuationFields.indexOf(field))
                {
                    postData.ValuationAppointments[field] = data[field];
                }
                else
                {
                    postData.Valuation[field] = data[field];
                }
            }

            if ('' != postData.ValuationAppointments.appointmentDate)
            {
                //var appointmentDate = new Date(postData.ValuationAppointments.appointmentDate);
                //
                //postData.ValuationAppointments.appointmentDate = appointmentDate;

                postData.ValuationAppointments.appointmentDate = postData.ValuationAppointments.appointmentDate + ' 00:00:00';
            }

            if( !isValidEmailAddress( postData.Valuation.email ) )
            {
                testEmail = postData.Valuation.email;
                //console.log("went through check", testEmail);
                postData.Valuation.email = null;
            }


            if ('' == postData.Valuation.email)
            {
                postData.Valuation.email = null;
            }

            return postData;
        },

        _onValuationUpdated : function( response )
        {
            //alert('Your vehicle has successfully been submitted.');
            //window.location.hash = '/valuationcalendar';

            //window.location.hash = "/valuationcalendar"; //Whatever is your hash value
            //location.reload();

            $('#calendar').fullCalendar('removeEvents');

            var userId = App.userData.id

            App.Ajax.JSON({
                    "url"  : 'workspace/get-calendar-events',
                    "data" : {'userId' : userId}
                },
                $.proxy(function(response) {

                    //console.log('response',response);

                    var calendarEvents = [];

                    $.each( response, function( responseKey, responseValue ) {

                        $.each( responseValue, function( responseK, responseV ) {

                            var startDate = responseV.start.replace("SAST", "T");
                            var endDate = responseV.end.replace("SAST", "T");

                            calendarEvents.push(
                                {
                                    'title' 				: responseV.title,
                                    'start' 				: startDate,
                                    'end' 				    : endDate,
                                    //'url' 					: '/#/appointmentedit',
                                    'id' 			        : responseV.appointmentId,
                                    'appointmentCompleted' 	: responseV.appointmentCompleted,
                                    'appointmentCancelled' 	: responseV.appointmentCancelled
                                }
                            );

                        });
                    });
                    //this.createCalendar(calendarEvents);

                    //console.log('calendarEvents',calendarEvents);

                    $('#calendar').fullCalendar( 'addEventSource', calendarEvents);

                },this),
                $.proxy(function(response) {
                    console.log('App.Notification.remove Error', response);
                },this)
            );



            $('#frmModal .close').click();

        },
        _onValuationFail : function( response )
        {
            alert('Oops, something went wrong, please check your data carefully and try again.');
            //window.location.hash = '/public-landing';
        }

    };

})();