;(function(){

	_App.Router = function()
	{
		this.initialize();
	};

	_App.Router.prototype =
	{

		routes :
		{
			// Public
			'#/thankyouvaluation'    : 'thankyouvaluation',
			'#/thankyoucontact'      : 'thankyoucontact',
			'#/publicfaq'            : 'publicfaq',
			'#/publiccontact_us'     : 'publiccontact_us',
			'#/publicvaluation'      : 'publicvaluation',
			'#/publichome'           : 'publichome',

			// Brochure
			''                       : 'dealerhome',
			'#/'                     : 'dealerhome',
			'#/dealerhome'           : 'dealerhome',
			'#/faq'                  : 'faq',
			'#/login'                : 'login',
			'#/forgot'               : 'forgot',
			'#/contact'              : 'contact',
			'#/register'             : 'register',
			'#/registered'           : 'registered',
			'#/contact_us'           : 'contact_us',
			'#/about_us'             : 'about_us',
			'#/terms_and_conditions' : 'terms_and_conditions',
			'#/unsubscribe-newsletter': 'unsubscribenewsletter',
            '#/customervaluation'      : 'customervaluation',
            '#/customercompletevaluation'      : 'customercompletevaluation',


			// Portal
			'#/auction'              : 'auction',
			'#/bidview'              : 'bidview',
			'#/historyview'          : 'historyview',
			'#/stock'                : 'stock',
			'#/stockview'            : 'stockview',
			'#/limitedstockview'     : 'limitedstockview',
			'#/tcstock'              : 'tcstock',
			'#/tcstockview'          : 'tcstockview',
			'#/limitedtcstockview'   : 'limitedtcstockview',
			'#/valuations'           : 'valuations',
			'#/valuationview'        : 'valuationview',
			'#/limitedvaluationview' : 'limitedvaluationview',
			'#/valuationreport'      : 'valuationreport',
			'#/settings'             : 'settings',
			'#/userview'             : 'userview',
			'#/dealerview'           : 'dealerview',
			'#/membershipview'       : 'membershipview',
			'#/clubview'             : 'clubview',
			'#/memberview'           : 'memberview',
			'#/disputeview'          : 'disputeview',
			'#/questionview'         : 'questionview',
			'#/replyview'            : 'replyview',
			'#/retailview'           : 'retailview',
			'#/priceguide'           : 'priceguide',
			'#/offerview'            : 'offerview',
			'#/changepinview'        : 'changepinview',
      		'#/historicaldata'       : 'historicaldata',
            '#/valuationcalendar'      : 'valuationcalendar',
            '#/appointmentedit'      : 'appointmentedit',


			// Admin
			'#/switch'               : 'switch',
			'#/admin'                : 'admin',
			'#/userpermissions'      : 'userpermissions',
			'#/viewuserpermissions'  : 'viewuserpermissions',
			'#/systemusers'          : 'systemusers',
			'#/systemuserview'       : 'systemuserview',
			'#/systemauctions'       : 'systemauctions',
			'#/systembidview'        : 'systembidview',
			'#/systemdisputes'       : 'systemdisputes',
			'#/systemdisputeview'    : 'systemdisputeview',
			'#/override'             : 'override',
			'#/dealers'              : 'dealers',
			'#/systemdealerview'     : 'systemdealerview',
			'#/xmlrpcrequestlog'     : 'xmlrpcrequestlog',
			'#/xmlrpccallbacklog'    : 'xmlrpccallbacklog',
			'#/xmlrpcclients'        : 'xmlrpcclients',
			'#/xmlrpcclientview'     : 'xmlrpcclientview',
			'#/systemsettings'       : 'systemsettings',
			'#/configview'           : 'configview',
			'#/accessories'          : 'accessories',
			'#/damages'              : 'damages',
			'#/increments'           : 'increments',
			'#/groups'               : 'groups',
			'#/divisions'            : 'divisions',
			'#/holidays'             : 'holidays',
			'#/regionalmanager'      : 'regionalmanager',
			'#/opendays'             : 'opendays',
			'#/newsletters'          : 'newsletters',
			'#/newsletterview'       : 'newsletterview',
			'#/reports'              : 'reports',
			'#/smsreport'            : 'smsreport',
			'#/invreport'            : 'invreport',
			'#/auctionreport'        : 'auctionreport',
            '#/stockauctionreport'        : 'stockauctionreport',
            '#/stockbulkimporter'        : 'stockbulkimporter',
			'#/hpilogreport'         : 'hpilogreport',
            '#/hpiaccidentlogreport'         : 'hpiaccidentlogreport',
			'#/pgreport'             : 'pgreport',
			'#/traderreport'         : 'traderreport',
			'#/adhreport'			 : 'adhreport',
			'#/loadvssoldreport'	 : 'loadvssoldreport',
			'#/loadvssolddetreport'	 : 'loadvssolddetreport',
			'#/pgfreport'	 		 : 'pgfreport',
			'#/pgsreport'	 		 : 'pgsreport',
			'#/auctionadherence'	 : 'auctionadherence',
			'#/nomatch'	 			 : 'nomatch',
			'#/priceguideflash'	 	 : 'priceguideflash',
			'#/emailreport'	         : 'emailreport',
			'#/loginreport'	         : 'loginreport',
			'#/adminvaluationreport' : 'adminvaluationreport',
			'#/valuationstatreport'  : 'valuationstatreport',
      		'#/auctiontraderreport'  : 'auctiontraderreport',
      		'#/transunionupload'     : 'transunionupload'
		},

		requireMenu : {
			'thankyou'             : 'PublicMenu',
			'publicfaq'            : 'PublicMenu',
			'publiccontact_us'     : 'PublicMenu',
			'publicvaluation'      : 'PublicMenu',
            'customervaluation'      : 'PublicMenu',
			'publichome'           : 'PublicMenu',
			'home'                 : 'PublicMenu',
			'faq'                  : 'BrochureMenu',
			'login'                : 'BrochureMenu',
			'forgot'               : 'BrochureMenu',
			'contact'              : 'BrochureMenu',
			'register'             : 'BrochureMenu',
			'registered'           : 'BrochureMenu',
			'contact_us'           : 'BrochureMenu',
			'about_us'             : 'BrochureMenu',
			'terms_and_conditions' : 'BrochureMenu',
			'dealerhome'           : 'BrochureMenu'
		},

		requireAuth : {
			'auction'              : true,
			'bidview'              : true,
			'historyview'          : true,
			'stock'                : true,
			'stockview'            : true,
			'limitedstockview'     : true,
			'tcstock'              : true,
			'tcstockview'          : true,
			'limitedtcstockview'   : true,
			'valuations'           : true,
			'valuationview'        : true,
			'limitedvaluationview' : true,
			'valuationreport'      : true,
			'settings'             : true,
			'userview'             : true,
			'changepinview'        : true,
			'dealerview'           : true,
			'membershipview'       : true,
			'clubview'             : true,
			'memberview'           : true,
			'disputeview'          : true,
			'questionview'         : true,
			'replyview'            : true,
			'retailview'           : true,
			'priceguide'           : true,
			'offerview'            : true,
			'switch'               : true,
			'admin'                : true,
			'userpermissions'      : true,
			'viewuserpermissions'  : true,
			'systemusers'          : true,
			'systemuserview'       : true,
			'systemauctions'       : true,
			'systembidview'        : true,
			'systemdisputes'       : true,
			'systemdisputeview'    : true,
			'override'             : true,
			'dealers'              : true,
			'systemdealerview'     : true,
			'xmlrpcrequestlog'     : true,
			'xmlrpccallbacklog'    : true,
			'xmlrpcclients'        : true,
			'xmlrpcclientview'     : true,
			'systemsettings'       : true,
			'configview'           : true,
			'accessories'          : true,
			'damages'              : true,
			'increments'           : true,
			'groups'               : true,
			'divisions'            : true,
			'holidays'             : true,
			'regionalmanager'      : true,
			'opendays'             : true,
			'newsletters'          : true,
			'newsletterview'       : true,
			'reports'              : true,
			'smsreport'            : true,
			'invreport'            : true,
			'auctionreport'        : true,
			'hpilogreport'         : true,
            'hpiaccidentlogreport'         : true,
			'pgreport'             : true,
			'traderreport'         : true,
			'adhreport'            : true,
			'loadvssoldreport'     : true,
			'loadvssolddetreport'  : true,
			'pgfreport'  		   : true,
			'pgsreport'  		   : true,
			'auctionadherence' 	   : true,
			'NoMatch' 	   		   : true,
			'priceguideflash'  	   : true,
			'emailreport'          : true,
			'loginreport'          : true,
			'adminvaluationreport' : true,
			'valuationstatreport'  : true,
			'auctiontraderreport'  : true,
      		'historicaldata'       : true

		},
		initialize : function()
		{
			if( !window.location.hash.length )
			{
				window.location.hash = '/';
			}
			this.setupHashChangeListener();
		},

		setupHashChangeListener : function()
		{
			if( !( 'onhashchange' in window ) )
			{
				this.pollHash();
			}
			$(window).on('hashchange', $.proxy( this.handleHashChange, this ));
		},

		pollHash : function()
		{
			var currentHash = window.location.hash;
			setInterval( function(){
			if( window.location.hash != currentHash )
			{
				$(window).trigger('hashchange');
				currentHash = window.location.hash;
			}
			}, 250);
		},

		handleHashChange : function()
		{
			var hashLoc = window.location.hash.split("?");
			var page = this.routes[hashLoc[0]];
			if (this.requireAuth[page] && !App.Authenticated)
			{
				App.redirect = window.location.hash;
				window.location.hash = '/login';
				return;
			}

            if ('home' == page
                && ('cash-cars.local' == window.location.host
                || 'cash-cars.nirph.com' == window.location.host
                || 'www.wepay4cars.co.za' == window.location.host
                || 'wepay4cars.co.za' == window.location.host
                || 'www.wepay4cars.co.za' == window.location.host
                || 'wepay4cars.co.za' == window.location.host))
            {
                page = 'customervaluation';
            }

			if ('home' == page
				&& ('namibia.local' == window.location.host
					|| 'namibia.nirph.com' == window.location.host
					|| 'www.bid4cars.com.na' == window.location.host))
			{
				page = 'dealerhome';
			}
			if (this.requireMenu[page])
			{
				$('.is-brochure-menu').hide();
				$('#' + this.requireMenu[page]).show();
				$('#Mobi' + this.requireMenu[page]).show();
			}
			App.Controller.changePage( page );
			$(window).trigger('pageChange');
		}

	};

})();